Index: /code/branches/spaceraceTwo/data/levels/Spacerace2.oxw
===================================================================
--- /code/branches/spaceraceTwo/data/levels/Spacerace2.oxw	(revision 8944)
+++ /code/branches/spaceraceTwo/data/levels/Spacerace2.oxw	(revision 8944)
@@ -0,0 +1,66 @@
+<LevelInfo
+ name = "Spacerace2"
+ description = "Just a few tests"
+ tags = "test"
+/>
+
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+
+  include("templates/spaceshipAssff.oxt")
+ 
+?>
+
+<?lua
+  include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipPirate.oxt")
+?>
+
+<Level
+ name         = "Spacerace2"
+ description  = "Just a few tests"
+gametype = SpaceRace
+>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+  <?lua include("includes/notifications.oxi") ?>
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/Starbox"
+  >
+
+    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
+
+	
+	<SpaceRaceManager>
+<checkpoints>	
+	<RaceCheckPoint name="checkpoint1" position="0,-2000,1000" direction="0,-1,1" collisionType="static" scale="1" distance="40" checkpointindex="0" islast="true">
+        <attached>
+            <Model mass="50" scale="50" mesh="raceCheckPoint.mesh" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,55"      halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="0,0,-55"     halfExtents="55, 10, 10" />
+            <BoxCollisionShape position="55,0,0"      halfExtents="10, 10, 55" />
+            <BoxCollisionShape position="-55,0,0"     halfExtents="10, 10, 55" />
+        </collisionShapes>
+    </RaceCheckPoint>
+</checkpoints>
+</SpaceRaceManager>
+
+
+
+
+    <SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
+
+
+   
+
+    
+  </Scene>
+</Level>
+
Index: /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc
===================================================================
--- /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc	(revision 8943)
+++ /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc	(revision 8944)
@@ -46,4 +46,7 @@
         RegisterObject(SpaceRace);
         
+         const std::string& message = "SpaceRace constructed";
+         orxout()<< message << endl;
+    
         this->bTimeIsUp_ = false;
         this->numberOfBots_ = 0;
@@ -52,4 +55,6 @@
        for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
         {this->checkpointReached_[it->first]=0;}
+        
+        
     }
     
@@ -92,6 +97,7 @@
 
     void SpaceRace::start()
-    {
-  	  		   this->spawnPlayersIfRequested(); Gametype::checkStart(); 
+    { 
+    		Gametype::start();
+  	  		   this->spawnPlayersIfRequested(); //Gametype::checkStart(); 
   	  		   this->cantMove_=true; 
     	 
Index: /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc
===================================================================
--- /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc	(revision 8943)
+++ /code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc	(revision 8944)
@@ -45,5 +45,7 @@
     {
         RegisterObject(SpaceRaceManager);
-                
+         
+          const std::string& message = "SpaceRaceManager constructed";
+         orxout()<< message << endl;      
     }
 
Index: /code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc
===================================================================
--- /code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc	(revision 8943)
+++ /code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc	(revision 8944)
@@ -134,6 +134,11 @@
                 
             }
-                 
-           	this->checkStart();
+            
+             const std::string& message = "Gametype should start";
+         orxout()<< message << endl;    
+           	this->start();
+           	const std::string& message2 = "Gametype should have started";
+         orxout()<< message2 << endl;
+         
         }
         else if (!this->gtinfo_->hasEnded())
@@ -144,5 +149,7 @@
 
     void Gametype::start()
-    {
+    { const std::string& message = "Gametype starts";
+         orxout()<< message << endl;
+         
         this->addBots(this->numberOfBots_);
 
@@ -150,4 +157,6 @@
 
         this->spawnPlayersIfRequested();
+        
+         
     }
 
Index: /code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc
===================================================================
--- /code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc	(revision 8943)
+++ /code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc	(revision 8944)
@@ -164,8 +164,12 @@
     {
         if(this->bStarted_)
-            return;
+           {const std::string& message = "bStarted true";
+         orxout()<< message << endl; return;}
         
         this->bStarted_ = true;
         this->changedStarted();
+        
+        const std::string& message = "bStarted true";
+         orxout()<< message << endl;
     }
 