Index: code/branches/spaceraceTwo/data/levels/Spacerace2.oxw
===================================================================
--- code/branches/spaceraceTwo/data/levels/Spacerace2.oxw	(revision 8948)
+++ code/branches/spaceraceTwo/data/levels/Spacerace2.oxw	(revision 8949)
@@ -53,5 +53,16 @@
 </SpaceRaceManager>
 
-
+ <SpaceShip position="0,2000,2000" lookat="0,0,0" team=1 >
+      <templates>
+        <Template link=spaceshipassff />
+      </templates>
+      <controller>
+         <WaypointPatrolController alertnessradius=1500 team=0 >
+            <waypoints>
+                <Model scale=0 position="0,2000,2000" />
+            </waypoints>
+         </WaypointPatrolController>
+      </controller>
+    </SpaceShip>
 
 
Index: code/branches/spaceraceTwo/src/modules/gametypes/RaceCheckPoint.cc
===================================================================
--- code/branches/spaceraceTwo/src/modules/gametypes/RaceCheckPoint.cc	(revision 8948)
+++ code/branches/spaceraceTwo/src/modules/gametypes/RaceCheckPoint.cc	(revision 8949)
@@ -39,17 +39,21 @@
 {
     CreateFactory(RaceCheckPoint);
+    
+      
 
     RaceCheckPoint::RaceCheckPoint(BaseObject* creator): DistanceTrigger(creator), RadarViewable(creator, static_cast<WorldEntity*>(this))
     {
         RegisterObject(RaceCheckPoint);
-
+        
+	
+           
         this->bCheckpointIndex_ = 0;
         //this->bIsLast_ = false;
         this->bTimeLimit_ = 0;
-        this->isVisible_=false;
+        this->isVisible_=true;
 
         this->setRadarObjectColour(ColourValue::Blue);
         this->setRadarObjectShape(RadarViewable::Triangle);
-        this->setRadarVisibility(false);
+        this->setRadarVisibility(true);
     }
 
@@ -58,6 +62,6 @@
     	 //if (this->isInitialized())
         {
-            //for (size_t i = 0; i < this->nextcheckpoints_.size(); ++i)
-              //  this->nextcheckpoints_[i]->destroy();
+            //for (size_t i = 0; i < 3; ++i)
+            //   this->nextcheckpoints_[i]->destroy();
         }
        //nextcheckpoints_.destroy;
@@ -72,4 +76,6 @@
         if(this->isVisible_){this->setRadarVisibility(true);}
         else{this->setRadarVisibility(false);}
+       
+       
         /*this->setRadarVisibility(false);
         Vector3 v =Vector3(0,0,0);
Index: code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc
===================================================================
--- code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc	(revision 8948)
+++ code/branches/spaceraceTwo/src/modules/gametypes/SpaceRace.cc	(revision 8949)
@@ -46,10 +46,10 @@
         RegisterObject(SpaceRace);
         
-         const std::string& message = "SpaceRace constructed";
-         orxout()<< message << endl;
+        
     
         this->bTimeIsUp_ = false;
         this->numberOfBots_ = 0;
         this->cantMove_=false;
+        
         
        for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
@@ -97,7 +97,7 @@
 
     void SpaceRace::start()
-    { 
-    		Gametype::start();
-  	  		   this->spawnPlayersIfRequested(); //Gametype::checkStart(); 
+    {
+    		//Gametype::start();
+  	  		   this->spawnPlayersIfRequested(); Gametype::checkStart(); 
   	  		   this->cantMove_=true; 
     	 
@@ -117,5 +117,5 @@
   	  		       
   	  		       this->addBots(this->numberOfBots_); 
-       
+      
     }
     
@@ -144,5 +144,5 @@
 
 	void SpaceRace::setV(SpaceRaceManager* m){
-		Vector3 v =Vector3(0,0,0);
+		/*Vector3 v =Vector3(0,0,0);
         int j=0;
         for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
@@ -152,8 +152,9 @@
         	v=r->getNextcheckpoint();
         	for(int i=1;i<4;i++){
-        	 RaceCheckPoint* n=m->getCheckpoint(i);
+        	if(v[i]==0){
+        	 RaceCheckPoint* n=m->getCheckpoint(v[i]);
            	 n->setV(true);
-           	 }
-	}
+           	 }}
+	}*/
 	}
 
@@ -191,16 +192,18 @@
 
 void SpaceRace::playerEntered(PlayerInfo* player){
-    	this->checkpointReached_[player]=0;
-    	this->playersAlive_++;
+	Gametype::playerEntered(player);
+    	//this->checkpointReached_[player]=0;
+    	//this->playersAlive_++;
     }
     
 	bool SpaceRace::playerLeft(PlayerInfo* player){
-		 bool valid_player = true;
-        if (valid_player)
-        {
-            this->playersAlive_--;
-        }
-
-        return valid_player;
+	return Gametype::playerLeft(player);
+		// bool valid_player = true;
+        //if (valid_player)
+       // {
+        //    this->playersAlive_--;
+        //}
+
+       // return valid_player;
 	}
 }
Index: code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc
===================================================================
--- code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc	(revision 8948)
+++ code/branches/spaceraceTwo/src/modules/gametypes/SpaceRaceManager.cc	(revision 8949)
@@ -46,6 +46,5 @@
         RegisterObject(SpaceRaceManager);
          
-          const std::string& message = "SpaceRaceManager constructed";
-         orxout()<< message << endl;      
+          
     }
 
Index: code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc
===================================================================
--- code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc	(revision 8948)
+++ code/branches/spaceraceTwo/src/orxonox/gametypes/Gametype.cc	(revision 8949)
@@ -134,10 +134,7 @@
                 
             }
-            
-             const std::string& message = "Gametype should start";
-         orxout()<< message << endl;    
-           	this->start();
-           	const std::string& message2 = "Gametype should have started";
-         orxout()<< message2 << endl;
+              
+           	this->checkStart();
+           
          
         }
@@ -149,6 +146,5 @@
 
     void Gametype::start()
-    { const std::string& message = "Gametype starts";
-         orxout()<< message << endl;
+    {
          
         this->addBots(this->numberOfBots_);
@@ -158,5 +154,5 @@
         this->spawnPlayersIfRequested();
         
-         
+        
     }
 
@@ -387,5 +383,5 @@
                 {
                     this->gtinfo_->stopStartCountdown();
-                    this->gtinfo_->setStartCountdown(0.0f);;
+                    this->gtinfo_->setStartCountdown(0.0f);
                     this->start();
                 }
@@ -408,4 +404,5 @@
                             hashumanplayers = true;
                     }
+                         
                     if (allplayersready && hashumanplayers)
                     {
@@ -419,4 +416,5 @@
                 }
             }
+            
         }
     }
Index: code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc
===================================================================
--- code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc	(revision 8948)
+++ code/branches/spaceraceTwo/src/orxonox/infos/GametypeInfo.cc	(revision 8949)
@@ -164,12 +164,10 @@
     {
         if(this->bStarted_)
-           {const std::string& message = "bStarted true";
-         orxout()<< message << endl; return;}
+           { return;}
         
         this->bStarted_ = true;
         this->changedStarted();
         
-        const std::string& message = "bStarted true";
-         orxout()<< message << endl;
+       
     }
 