Index: /code/branches/gamecontent/data/levels/missionOne.oxw
===================================================================
--- /code/branches/gamecontent/data/levels/missionOne.oxw	(revision 8950)
+++ /code/branches/gamecontent/data/levels/missionOne.oxw	(revision 8951)
@@ -432,5 +432,5 @@
 
 
-    <SimpleNotification message="Three red arrows just appeared.">
+    <SimpleNotification message="Three arrows just appeared.">
         <events>
             <trigger>
@@ -441,5 +441,5 @@
 
     <DistanceTrigger name="flying5" position="-900,640,600" target="Pawn" distance=60 stayActive="true" delay=5/>
-    <SimpleNotification message="Follow those red arrows.">
+    <SimpleNotification message="Follow those arrows.">
         <events>
             <trigger>
@@ -510,57 +510,59 @@
 
 <!-- @Objects: 4 boxes (uncontrolled pawns) -->
-                <Pawn team=1 health=30 position="0,0,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box >
-                    <events>
-                      <visibility>
-                        <EventListener event="flying4" />
-                      </visibility>
-                    </events>
-                    <attached>
-                        <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
-                    </attached>
-                    <collisionShapes>
-                        <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
-                    </collisionShapes>
-                </Pawn>
-
-                <Pawn team=1 health=30 position="0,100,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box visible="true">
-                    <events>
-                      <visibility>
-                        <EventListener event="flying4" />
-                      </visibility>
-                    </events>
-                    <attached>
-                        <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
-                    </attached>
-                    <collisionShapes>
-                        <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
-                    </collisionShapes>
-                </Pawn>
-                <Pawn health=30 position="0,200,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box team=1>
-                    <events>
-                      <visibility>
-                        <EventListener event="flying4" />
-                      </visibility>
-                    </events>
-                    <attached>
-                        <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
-                    </attached>
-                    <collisionShapes>
-                        <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
-                    </collisionShapes>
-                </Pawn>
-                <Pawn health=30 position="0,300,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box team=1>
-                    <events>
-                      <visibility>
-                        <EventListener event="flying4" />
-                      </visibility>
-                    </events>
-                    <attached>
-                        <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
-                    </attached>
-                    <collisionShapes>
-                        <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
-                    </collisionShapes>
-                </Pawn>
+    <Pawn team=1 health=30 position="0,0,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box RVName = "Box 1" >
+        <events>
+          <visibility>
+            <EventListener event="flying4" />
+          </visibility>
+        </events>
+        <attached>
+            <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
+        </collisionShapes>
+    </Pawn>
+
+    <Pawn team=1 health=30 position="0,100,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box RVName = "Box 2">
+        <events>
+          <visibility>
+            <EventListener event="flying4" />
+          </visibility>
+        </events>
+        <attached>
+           <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
+        </collisionShapes>
+    </Pawn>
+
+    <Pawn health=30 position="0,200,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box team=1 RVName = "Box 3">
+        <events>
+          <visibility>
+            <EventListener event="flying4" />
+          </visibility>
+        </events>
+        <attached>
+           <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
+        </attached>
+        <collisionShapes>
+            <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
+        </collisionShapes>
+    </Pawn>
+
+    <Pawn health=30 position="0,300,0" direction="0,-1,0" collisionType=dynamic mass=100000 name=box team=1 RVName = "Box 4">
+        <events>
+          <visibility>
+            <EventListener event="flying4" />
+          </visibility>
+        </events>
+        <attached>
+            <Model position="0,0,0" mesh="crate.mesh" scale3D="3,3,3" />
+        </attached>
+        <collisionShapes>
+           <BoxCollisionShape position="0,0,0" halfExtents="15,15,15" />
+        </collisionShapes>
+    </Pawn>
 
 <!-- @Triggers: boxtrigger1 <-> one   box   destroyed
@@ -634,5 +636,5 @@
 
 <!-- @Objects: 2 pirates moving in squares, nonlethal -->
-                <SpaceShip position="0,2000,200" lookat="0,0,0" name="movingtarget" >
+                <SpaceShip position="0,2000,200" lookat="0,0,0" name="movingtarget" RVName="Pirate">
                             <events>
                                 <visibility>
@@ -655,5 +657,5 @@
                 </SpaceShip>
 
-                <SpaceShip position="0,2000,400" lookat="0,0,0" name="movingtarget">
+                <SpaceShip position="0,2000,400" lookat="0,0,0" name="movingtarget" RVName="Pirate">
                             <events>
                                 <visibility>
@@ -924,5 +926,5 @@
 
 
-    <SimpleNotification message="Dock to the Hydrogen Farmer.">
+    <SimpleNotification message="Dock to the Hydrogen Farmer." broadcast="true">
         <events>
             <trigger>
@@ -956,5 +958,5 @@
     </Trigger>
 
-    <SimpleNotification message="We just received a message from DuBall.">
+    <SimpleNotification message="We just received a message from DuBall." broadcast="true">
         <events>
             <trigger>
@@ -965,5 +967,5 @@
 
 
-    <SimpleNotification message="We will lend you our strongest ship.">
+    <SimpleNotification message="We will lend you our strongest ship." broadcast="true">
         <events>
             <trigger>
@@ -976,10 +978,11 @@
 <!-- @Objects: HYDROGEN FARMER & DOCKING -->
     <SpaceShip
-        team=0
-        position="-48900,100,0"
-        roll=90 yaw=0 pitch=20
-        mass=10000
-        health=100000 initialhealth=100000 maxhealth="100000"
-        name="HydroFarmer">
+        team     = 0
+        position = "-48900,100,0"
+        roll     = 90   yaw=0  pitch=20
+        mass     = 10000
+        health   = 100000 initialhealth=100000 maxhealth="100000"
+        name     = "HydroFarmer"
+        RVName   = "Hydrogen Farmer" >
       <attached>
         <!-- Docking -->
@@ -1063,5 +1066,6 @@
         reloadrate          = "1"
         reloadwaittime      = "1"
-        name                = "cruiser" >
+        name                = "cruiser"
+        RVName              = "Spacecruiser" >
       <attached>
         <DockingTarget name="spaceShip" />
Index: /code/branches/gamecontent/src/orxonox/controllers/ArtificialController.h
===================================================================
--- /code/branches/gamecontent/src/orxonox/controllers/ArtificialController.h	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/controllers/ArtificialController.h	(revision 8951)
@@ -51,5 +51,5 @@
             void abandonTarget(Pawn* target);
 
-            inline void setTeam(int team)
+            inline void setTeam(int team) //TODO: write through to controllable entity.
                 { this->team_ = team; }
             inline int getTeam() const
Index: /code/branches/gamecontent/src/orxonox/gametypes/TeamGametype.cc
===================================================================
--- /code/branches/gamecontent/src/orxonox/gametypes/TeamGametype.cc	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/gametypes/TeamGametype.cc	(revision 8951)
@@ -59,8 +59,12 @@
         static ColourValue colours[] =
         {
-            ColourValue(1.0f, 0.3f, 0.3f),
-            ColourValue(0.3f, 0.3f, 1.0f),
+            ColourValue(0.2f, 0.2f, 1.0f),
+            ColourValue(1.0f, 0.1f, 0.1f),
             ColourValue(0.3f, 1.0f, 0.3f),
-            ColourValue(1.0f, 1.0f, 0.0f)
+            ColourValue(1.0f, 1.0f, 0.0f),
+            ColourValue(0.0f, 1.0f, 1.0f),
+            ColourValue(1.0f, 0.0f, 1.0f),
+            ColourValue(7.0f, 7.0f, 7.0f),
+            ColourValue(2.0f, 2.0f, 2.0f)
         };
         static std::vector<ColourValue> defaultcolours(colours, colours + sizeof(colours) / sizeof(ColourValue));
Index: /code/branches/gamecontent/src/orxonox/interfaces/CMakeLists.txt
===================================================================
--- /code/branches/gamecontent/src/orxonox/interfaces/CMakeLists.txt	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/interfaces/CMakeLists.txt	(revision 8951)
@@ -6,4 +6,3 @@
   PickupListener.cc
   RadarViewable.cc
-  PartyMember.cc
 )
Index: de/branches/gamecontent/src/orxonox/interfaces/PartyMember.cc
===================================================================
--- /code/branches/gamecontent/src/orxonox/interfaces/PartyMember.cc	(revision 8950)
+++ 	(revision )
@@ -1,72 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Damian 'Mozork' Frick
- *   Co-authors:
- *      ...
- *
-*/
-
-/**
-    @file PartyMember.cc
-    @brief Implementation of the PartyMember class.
-*/
-
-#include "OrxonoxPrereqs.h"
-
-#include "core/CoreIncludes.h"
-
-#include "PartyMember.h"
-
-namespace orxonox
-{
-
-    /**
-    @brief
-        Constructor. Registers the object.
-    */
-    PartyMember::PartyMember()
-    {
-        RegisterRootObject(PartyMember);
-        this->team_ = -1;
-    }
-
-    /**
-    @brief
-        Destructor.
-    */
-    PartyMember::~PartyMember()
-    {
-
-    }
-
-    /**
-    @brief
-        Static method that is used to notify the PartyMember itself of the change in the used status of a Pickupable.
-        This is called in Pickupable.
-    @param pickup
-        The Pickupable that has changed its used status.
-    @param used
-        Thse value the status has changed to.
-    */
-
-}
Index: de/branches/gamecontent/src/orxonox/interfaces/PartyMember.h
===================================================================
--- /code/branches/gamecontent/src/orxonox/interfaces/PartyMember.h	(revision 8950)
+++ 	(revision )
@@ -1,81 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Damian 'Mozork' Frick
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @brief Definition of the PartyMember class.
-*/
-
-#ifndef _PartyMember_H__
-#define _PartyMember_H__
-
-#include "OrxonoxPrereqs.h"
-#include "core/OrxonoxClass.h"
-
-namespace orxonox
-{
-    /**
-    @brief
-        PartyMember is an Interface, that can be implemented by any object to enable it to belong to a certain group. (friend, foe, neutral, ...)
-
-        It just needs to inherit form PartyMember, and implement the  methods.
-    @author
-        Damian 'Mozork' Frick
-    */
-    class _OrxonoxExport PartyMember : virtual public OrxonoxClass
-    {
-        public:
-            PartyMember();
-            virtual ~PartyMember();
-
-
-
-            /**
-            @brief
-                Method to set the objects teamnumber.
-                Must be implemented by every class inheriting from PartyMember. It is virtual in order to allow to implement a hirarchy.
-                Hirarchy: PlayerInfo > Controller > Pawn. When the level is set in the controller it should be also set in the controlled pawn.
-            @param team The teamnumber to which a PartyMember belongs to. Value '-1' means no team is set. 0,1,2, ... are legal team numbers.
-
-            @return
-
-            */
-            virtual inline void setTeam(int team) =0;
-
-            inline int getTeam() const
-                { return this->team_; }
-
-        protected:
-            int team_; //<! Teamnumber: to identify to which group a PartyMember belongs to
-                       //<! Default value: -1 : neutral the meaning of other values is defined in the context
-
-
-    };
-}
-
-#endif /* _PartyMember_H__ */
Index: /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.cc
===================================================================
--- /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.cc	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.cc	(revision 8951)
@@ -87,4 +87,5 @@
         this->setPriority( Priority::VeryHigh );
         this->registerVariables();
+	this->team_ = -1;
     }
 
@@ -119,4 +120,5 @@
         SUPER(ControllableEntity, XMLPort, xmlelement, mode);
 
+        XMLPortParam(ControllableEntity, "team", setTeam, getTeam, xmlelement, mode).defaultValues(-1);
         XMLPortParam(ControllableEntity, "hudtemplate", setHudTemplate, getHudTemplate, xmlelement, mode);
         XMLPortParam(ControllableEntity, "camerapositiontemplate", setCameraPositionTemplate, getCameraPositionTemplate, xmlelement, mode);
Index: /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.h	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/worldentities/ControllableEntity.h	(revision 8951)
@@ -163,4 +163,9 @@
                 { return this->target_.get(); }
             void setTargetInternal( uint32_t targetID );
+
+	    inline void setTeam(int team)
+	        { this->team_ = team; }
+	    inline float getTeam() const
+	        { return this->team_; }
 
         protected:
@@ -237,4 +242,6 @@
             CameraPosition* reverseCamera_;
             WeakPtr<WorldEntity> target_;
+
+	    int team_ ; //<! teamnumber
     };
 }
Index: /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.cc
===================================================================
--- /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.cc	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.cc	(revision 8951)
@@ -60,5 +60,4 @@
         this->bReload_ = false;
 
-        this->team_ = -1;
         this->health_ = 0;
         this->maxHealth_ = 0;
@@ -110,6 +109,4 @@
     {
         SUPER(Pawn, XMLPort, xmlelement, mode);
-
-        XMLPortParam(Pawn, "team", setTeam, getTeam, xmlelement, mode).defaultValues(-1);
 
         XMLPortParam(Pawn, "health", setHealth, getHealth, xmlelement, mode).defaultValues(100);
Index: /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.h
===================================================================
--- /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.h	(revision 8950)
+++ /code/branches/gamecontent/src/orxonox/worldentities/pawns/Pawn.h	(revision 8951)
@@ -35,5 +35,4 @@
 #include "interfaces/PickupCarrier.h"
 #include "interfaces/RadarViewable.h"
-#include "interfaces/PartyMember.h"
 #include "worldentities/ControllableEntity.h"
 
@@ -41,5 +40,5 @@
 { // tolua_export
     class _OrxonoxExport Pawn // tolua_export
-        : public ControllableEntity, public RadarViewable, public PickupCarrier//, public PartyMember
+        : public ControllableEntity, public RadarViewable, public PickupCarrier
     { // tolua_export
         friend class WeaponSystem;
@@ -55,8 +54,4 @@
                 { return this->bAlive_; }
 
-            inline void setTeam(int team)
-                { this->team_ = team; }
-            inline float getTeam() const
-                { return this->team_; }
 
             virtual void setHealth(float health);
@@ -200,5 +195,4 @@
                 { return NULL; }
 
-            int team_;
 
             float health_;